package ESpice.diagram.navigator;

import org.eclipse.gmf.runtime.common.ui.services.parser.IParser;
import org.eclipse.gmf.runtime.common.ui.services.parser.ParserOptions;
import org.eclipse.gmf.runtime.emf.core.util.EObjectAdapter;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.resource.ImageRegistry;
import org.eclipse.jface.viewers.ITreePathLabelProvider;
import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.jface.viewers.TreePath;
import org.eclipse.jface.viewers.ViewerLabel;
import org.eclipse.swt.graphics.Image;
import org.eclipse.ui.IMemento;
import org.eclipse.ui.navigator.ICommonContentExtensionSite;
import org.eclipse.ui.navigator.ICommonLabelProvider;

/**
 * @generated
 */
public class ESpiceNavigatorLabelProvider extends LabelProvider implements
		ICommonLabelProvider, ITreePathLabelProvider {

	/**
	 * @generated
	 */
	static {
		ESpice.diagram.part.ESpiceDiagramEditorPlugin
				.getInstance()
				.getImageRegistry()
				.put(
						"Navigator?UnknownElement", ImageDescriptor.getMissingImageDescriptor()); //$NON-NLS-1$
		ESpice.diagram.part.ESpiceDiagramEditorPlugin
				.getInstance()
				.getImageRegistry()
				.put(
						"Navigator?ImageNotFound", ImageDescriptor.getMissingImageDescriptor()); //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	public void updateLabel(ViewerLabel label, TreePath elementPath) {
		Object element = elementPath.getLastSegment();
		if (element instanceof ESpice.diagram.navigator.ESpiceNavigatorItem
				&& !isOwnView(((ESpice.diagram.navigator.ESpiceNavigatorItem) element)
						.getView())) {
			return;
		}
		label.setText(getText(element));
		label.setImage(getImage(element));
	}

	/**
	 * @generated
	 */
	public Image getImage(Object element) {
		if (element instanceof ESpice.diagram.navigator.ESpiceNavigatorGroup) {
			ESpice.diagram.navigator.ESpiceNavigatorGroup group = (ESpice.diagram.navigator.ESpiceNavigatorGroup) element;
			return ESpice.diagram.part.ESpiceDiagramEditorPlugin.getInstance()
					.getBundledImage(group.getIcon());
		}

		if (element instanceof ESpice.diagram.navigator.ESpiceNavigatorItem) {
			ESpice.diagram.navigator.ESpiceNavigatorItem navigatorItem = (ESpice.diagram.navigator.ESpiceNavigatorItem) element;
			if (!isOwnView(navigatorItem.getView())) {
				return super.getImage(element);
			}
			return getImage(navigatorItem.getView());
		}

		return super.getImage(element);
	}

	/**
	 * @generated
	 */
	public Image getImage(View view) {
		switch (ESpice.diagram.part.ESpiceVisualIDRegistry.getVisualID(view)) {
		case ESpice.diagram.edit.parts.OrganizationEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Diagram?ESpice?Organization", ESpice.diagram.providers.ESpiceElementTypes.Organization_79); //$NON-NLS-1$
		case ESpice.diagram.edit.parts.WiderstandEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?ESpice?Widerstand", ESpice.diagram.providers.ESpiceElementTypes.Widerstand_1001); //$NON-NLS-1$
		case ESpice.diagram.edit.parts.KnotenEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?ESpice?Knoten", ESpice.diagram.providers.ESpiceElementTypes.Knoten_1002); //$NON-NLS-1$
		case ESpice.diagram.edit.parts.StromquelleEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?ESpice?Stromquelle", ESpice.diagram.providers.ESpiceElementTypes.Stromquelle_1003); //$NON-NLS-1$
		case ESpice.diagram.edit.parts.KnotenKKEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?ESpice?Knoten?KK", ESpice.diagram.providers.ESpiceElementTypes.KnotenKK_3001); //$NON-NLS-1$
		case ESpice.diagram.edit.parts.BausteinBKEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?ESpice?Baustein?BK", ESpice.diagram.providers.ESpiceElementTypes.BausteinBK_3002); //$NON-NLS-1$
		}
		return getImage("Navigator?UnknownElement", null); //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private Image getImage(String key, IElementType elementType) {
		ImageRegistry imageRegistry = ESpice.diagram.part.ESpiceDiagramEditorPlugin
				.getInstance().getImageRegistry();
		Image image = imageRegistry.get(key);
		if (image == null
				&& elementType != null
				&& ESpice.diagram.providers.ESpiceElementTypes
						.isKnownElementType(elementType)) {
			image = ESpice.diagram.providers.ESpiceElementTypes
					.getImage(elementType);
			imageRegistry.put(key, image);
		}

		if (image == null) {
			image = imageRegistry.get("Navigator?ImageNotFound"); //$NON-NLS-1$
			imageRegistry.put(key, image);
		}
		return image;
	}

	/**
	 * @generated
	 */
	public String getText(Object element) {
		if (element instanceof ESpice.diagram.navigator.ESpiceNavigatorGroup) {
			ESpice.diagram.navigator.ESpiceNavigatorGroup group = (ESpice.diagram.navigator.ESpiceNavigatorGroup) element;
			return group.getGroupName();
		}

		if (element instanceof ESpice.diagram.navigator.ESpiceNavigatorItem) {
			ESpice.diagram.navigator.ESpiceNavigatorItem navigatorItem = (ESpice.diagram.navigator.ESpiceNavigatorItem) element;
			if (!isOwnView(navigatorItem.getView())) {
				return null;
			}
			return getText(navigatorItem.getView());
		}

		return super.getText(element);
	}

	/**
	 * @generated
	 */
	public String getText(View view) {
		if (view.getElement() != null && view.getElement().eIsProxy()) {
			return getUnresolvedDomainElementProxyText(view);
		}
		switch (ESpice.diagram.part.ESpiceVisualIDRegistry.getVisualID(view)) {
		case ESpice.diagram.edit.parts.OrganizationEditPart.VISUAL_ID:
			return getOrganization_79Text(view);
		case ESpice.diagram.edit.parts.WiderstandEditPart.VISUAL_ID:
			return getWiderstand_1001Text(view);
		case ESpice.diagram.edit.parts.KnotenEditPart.VISUAL_ID:
			return getKnoten_1002Text(view);
		case ESpice.diagram.edit.parts.StromquelleEditPart.VISUAL_ID:
			return getStromquelle_1003Text(view);
		case ESpice.diagram.edit.parts.KnotenKKEditPart.VISUAL_ID:
			return getKnotenKK_3001Text(view);
		case ESpice.diagram.edit.parts.BausteinBKEditPart.VISUAL_ID:
			return getBausteinBK_3002Text(view);
		}
		return getUnknownElementText(view);
	}

	/**
	 * @generated
	 */
	private String getOrganization_79Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getWiderstand_1001Text(View view) {
		IParser parser = ESpice.diagram.providers.ESpiceParserProvider
				.getParser(
						ESpice.diagram.providers.ESpiceElementTypes.Widerstand_1001,
						view.getElement() != null ? view.getElement() : view,
						ESpice.diagram.part.ESpiceVisualIDRegistry
								.getType(ESpice.diagram.edit.parts.WiderstandIdEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			ESpice.diagram.part.ESpiceDiagramEditorPlugin.getInstance()
					.logError("Parser was not found for label " + 4001); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getKnoten_1002Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getStromquelle_1003Text(View view) {
		IParser parser = ESpice.diagram.providers.ESpiceParserProvider
				.getParser(
						ESpice.diagram.providers.ESpiceElementTypes.Stromquelle_1003,
						view.getElement() != null ? view.getElement() : view,
						ESpice.diagram.part.ESpiceVisualIDRegistry
								.getType(ESpice.diagram.edit.parts.StromquelleIdEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			ESpice.diagram.part.ESpiceDiagramEditorPlugin.getInstance()
					.logError("Parser was not found for label " + 4002); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getKnotenKK_3001Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getBausteinBK_3002Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getUnknownElementText(View view) {
		return "<UnknownElement Visual_ID = " + view.getType() + ">"; //$NON-NLS-1$  //$NON-NLS-2$
	}

	/**
	 * @generated
	 */
	private String getUnresolvedDomainElementProxyText(View view) {
		return "<Unresolved domain element Visual_ID = " + view.getType() + ">"; //$NON-NLS-1$  //$NON-NLS-2$
	}

	/**
	 * @generated
	 */
	public void init(ICommonContentExtensionSite aConfig) {
	}

	/**
	 * @generated
	 */
	public void restoreState(IMemento aMemento) {
	}

	/**
	 * @generated
	 */
	public void saveState(IMemento aMemento) {
	}

	/**
	 * @generated
	 */
	public String getDescription(Object anElement) {
		return null;
	}

	/**
	 * @generated
	 */
	private boolean isOwnView(View view) {
		return ESpice.diagram.edit.parts.OrganizationEditPart.MODEL_ID
				.equals(ESpice.diagram.part.ESpiceVisualIDRegistry
						.getModelID(view));
	}

}
