package ESpice.diagram.providers;

import java.util.HashSet;
import java.util.IdentityHashMap;
import java.util.Map;
import java.util.Set;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.ENamedElement;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.gmf.runtime.emf.type.core.ElementTypeRegistry;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.resource.ImageRegistry;
import org.eclipse.swt.graphics.Image;

/**
 * @generated
 */
public class ESpiceElementTypes extends ElementInitializers {

	/**
	 * @generated
	 */
	private ESpiceElementTypes() {
	}

	/**
	 * @generated
	 */
	private static Map elements;

	/**
	 * @generated
	 */
	private static ImageRegistry imageRegistry;

	/**
	 * @generated
	 */
	private static Set KNOWN_ELEMENT_TYPES;

	/**
	 * @generated
	 */
	public static final IElementType Organization_79 = getElementType("ESpice.diagram.Organization_79"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType Widerstand_1001 = getElementType("ESpice.diagram.Widerstand_1001"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType Knoten_1002 = getElementType("ESpice.diagram.Knoten_1002"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType Stromquelle_1003 = getElementType("ESpice.diagram.Stromquelle_1003"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType KnotenKK_3001 = getElementType("ESpice.diagram.KnotenKK_3001"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType BausteinBK_3002 = getElementType("ESpice.diagram.BausteinBK_3002"); //$NON-NLS-1$

	/**
	 * @generated
	 */
	private static ImageRegistry getImageRegistry() {
		if (imageRegistry == null) {
			imageRegistry = new ImageRegistry();
		}
		return imageRegistry;
	}

	/**
	 * @generated
	 */
	private static String getImageRegistryKey(ENamedElement element) {
		return element.getName();
	}

	/**
	 * @generated
	 */
	private static ImageDescriptor getProvidedImageDescriptor(
			ENamedElement element) {
		if (element instanceof EStructuralFeature) {
			EStructuralFeature feature = ((EStructuralFeature) element);
			EClass eContainingClass = feature.getEContainingClass();
			EClassifier eType = feature.getEType();
			if (eContainingClass != null && !eContainingClass.isAbstract()) {
				element = eContainingClass;
			} else if (eType instanceof EClass
					&& !((EClass) eType).isAbstract()) {
				element = eType;
			}
		}
		if (element instanceof EClass) {
			EClass eClass = (EClass) element;
			if (!eClass.isAbstract()) {
				return ESpice.diagram.part.ESpiceDiagramEditorPlugin
						.getInstance().getItemImageDescriptor(
								eClass.getEPackage().getEFactoryInstance()
										.create(eClass));
			}
		}
		// TODO : support structural features
		return null;
	}

	/**
	 * @generated
	 */
	public static ImageDescriptor getImageDescriptor(ENamedElement element) {
		String key = getImageRegistryKey(element);
		ImageDescriptor imageDescriptor = getImageRegistry().getDescriptor(key);
		if (imageDescriptor == null) {
			imageDescriptor = getProvidedImageDescriptor(element);
			if (imageDescriptor == null) {
				imageDescriptor = ImageDescriptor.getMissingImageDescriptor();
			}
			getImageRegistry().put(key, imageDescriptor);
		}
		return imageDescriptor;
	}

	/**
	 * @generated
	 */
	public static Image getImage(ENamedElement element) {
		String key = getImageRegistryKey(element);
		Image image = getImageRegistry().get(key);
		if (image == null) {
			ImageDescriptor imageDescriptor = getProvidedImageDescriptor(element);
			if (imageDescriptor == null) {
				imageDescriptor = ImageDescriptor.getMissingImageDescriptor();
			}
			getImageRegistry().put(key, imageDescriptor);
			image = getImageRegistry().get(key);
		}
		return image;
	}

	/**
	 * @generated
	 */
	public static ImageDescriptor getImageDescriptor(IAdaptable hint) {
		ENamedElement element = getElement(hint);
		if (element == null) {
			return null;
		}
		return getImageDescriptor(element);
	}

	/**
	 * @generated
	 */
	public static Image getImage(IAdaptable hint) {
		ENamedElement element = getElement(hint);
		if (element == null) {
			return null;
		}
		return getImage(element);
	}

	/**
	 * Returns 'type' of the ecore object associated with the hint.
	 * 
	 * @generated
	 */
	public static ENamedElement getElement(IAdaptable hint) {
		Object type = hint.getAdapter(IElementType.class);
		if (elements == null) {
			elements = new IdentityHashMap();

			elements.put(Organization_79, ESpice.ESpicePackage.eINSTANCE
					.getOrganization());

			elements.put(Widerstand_1001, ESpice.ESpicePackage.eINSTANCE
					.getWiderstand());

			elements.put(Knoten_1002, ESpice.ESpicePackage.eINSTANCE
					.getKnoten());

			elements.put(Stromquelle_1003, ESpice.ESpicePackage.eINSTANCE
					.getStromquelle());

			elements.put(KnotenKK_3001, ESpice.ESpicePackage.eINSTANCE
					.getKnoten_KK());

			elements.put(BausteinBK_3002, ESpice.ESpicePackage.eINSTANCE
					.getBaustein_BK());
		}
		return (ENamedElement) elements.get(type);
	}

	/**
	 * @generated
	 */
	private static IElementType getElementType(String id) {
		return ElementTypeRegistry.getInstance().getType(id);
	}

	/**
	 * @generated
	 */
	public static boolean isKnownElementType(IElementType elementType) {
		if (KNOWN_ELEMENT_TYPES == null) {
			KNOWN_ELEMENT_TYPES = new HashSet();
			KNOWN_ELEMENT_TYPES.add(Organization_79);
			KNOWN_ELEMENT_TYPES.add(Widerstand_1001);
			KNOWN_ELEMENT_TYPES.add(Knoten_1002);
			KNOWN_ELEMENT_TYPES.add(Stromquelle_1003);
			KNOWN_ELEMENT_TYPES.add(KnotenKK_3001);
			KNOWN_ELEMENT_TYPES.add(BausteinBK_3002);
		}
		return KNOWN_ELEMENT_TYPES.contains(elementType);
	}

	/**
	 * @generated
	 */
	public static IElementType getElementType(int visualID) {
		switch (visualID) {
		case ESpice.diagram.edit.parts.OrganizationEditPart.VISUAL_ID:
			return Organization_79;
		case ESpice.diagram.edit.parts.WiderstandEditPart.VISUAL_ID:
			return Widerstand_1001;
		case ESpice.diagram.edit.parts.KnotenEditPart.VISUAL_ID:
			return Knoten_1002;
		case ESpice.diagram.edit.parts.StromquelleEditPart.VISUAL_ID:
			return Stromquelle_1003;
		case ESpice.diagram.edit.parts.KnotenKKEditPart.VISUAL_ID:
			return KnotenKK_3001;
		case ESpice.diagram.edit.parts.BausteinBKEditPart.VISUAL_ID:
			return BausteinBK_3002;
		}
		return null;
	}

}
