package ESpice.diagram.providers;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.common.core.service.AbstractProvider;
import org.eclipse.gmf.runtime.common.core.service.IOperation;
import org.eclipse.gmf.runtime.common.ui.services.parser.GetParserOperation;
import org.eclipse.gmf.runtime.common.ui.services.parser.IParser;
import org.eclipse.gmf.runtime.common.ui.services.parser.IParserProvider;
import org.eclipse.gmf.runtime.common.ui.services.parser.ParserService;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.emf.ui.services.parser.ParserHintAdapter;
import org.eclipse.gmf.runtime.notation.View;

/**
 * @generated
 */
public class ESpiceParserProvider extends AbstractProvider implements
		IParserProvider {

	/**
	 * @generated
	 */
	private IParser widerstandId_4001Parser;

	/**
	 * @generated
	 */
	private IParser getWiderstandId_4001Parser() {
		if (widerstandId_4001Parser == null) {
			EAttribute[] features = new EAttribute[] { ESpice.ESpicePackage.eINSTANCE
					.getWiderstand_Id() };
			ESpice.diagram.parsers.MessageFormatParser parser = new ESpice.diagram.parsers.MessageFormatParser(
					features);
			widerstandId_4001Parser = parser;
		}
		return widerstandId_4001Parser;
	}

	/**
	 * @generated
	 */
	private IParser stromquelleId_4002Parser;

	/**
	 * @generated
	 */
	private IParser getStromquelleId_4002Parser() {
		if (stromquelleId_4002Parser == null) {
			EAttribute[] features = new EAttribute[] { ESpice.ESpicePackage.eINSTANCE
					.getStromquelle_Id() };
			ESpice.diagram.parsers.MessageFormatParser parser = new ESpice.diagram.parsers.MessageFormatParser(
					features);
			stromquelleId_4002Parser = parser;
		}
		return stromquelleId_4002Parser;
	}

	/**
	 * @generated
	 */
	protected IParser getParser(int visualID) {
		switch (visualID) {
		case ESpice.diagram.edit.parts.WiderstandIdEditPart.VISUAL_ID:
			return getWiderstandId_4001Parser();
		case ESpice.diagram.edit.parts.StromquelleIdEditPart.VISUAL_ID:
			return getStromquelleId_4002Parser();
		}
		return null;
	}

	/**
	 * Utility method that consults ParserService
	 * @generated
	 */
	public static IParser getParser(IElementType type, EObject object,
			String parserHint) {
		return ParserService.getInstance().getParser(
				new HintAdapter(type, object, parserHint));
	}

	/**
	 * @generated
	 */
	public IParser getParser(IAdaptable hint) {
		String vid = (String) hint.getAdapter(String.class);
		if (vid != null) {
			return getParser(ESpice.diagram.part.ESpiceVisualIDRegistry
					.getVisualID(vid));
		}
		View view = (View) hint.getAdapter(View.class);
		if (view != null) {
			return getParser(ESpice.diagram.part.ESpiceVisualIDRegistry
					.getVisualID(view));
		}
		return null;
	}

	/**
	 * @generated
	 */
	public boolean provides(IOperation operation) {
		if (operation instanceof GetParserOperation) {
			IAdaptable hint = ((GetParserOperation) operation).getHint();
			if (ESpice.diagram.providers.ESpiceElementTypes.getElement(hint) == null) {
				return false;
			}
			return getParser(hint) != null;
		}
		return false;
	}

	/**
	 * @generated
	 */
	private static class HintAdapter extends ParserHintAdapter {

		/**
		 * @generated
		 */
		private final IElementType elementType;

		/**
		 * @generated
		 */
		public HintAdapter(IElementType type, EObject object, String parserHint) {
			super(object, parserHint);
			assert type != null;
			elementType = type;
		}

		/**
		 * @generated
		 */
		public Object getAdapter(Class adapter) {
			if (IElementType.class.equals(adapter)) {
				return elementType;
			}
			return super.getAdapter(adapter);
		}
	}

}
