/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package ESpice;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see ESpice.ESpiceFactory
 * @model kind="package"
 * @generated
 */
public interface ESpicePackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "ESpice";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "ESpice";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "ESpice";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	ESpicePackage eINSTANCE = ESpice.impl.ESpicePackageImpl.init();

	/**
	 * The meta object id for the '{@link ESpice.impl.OrganizationImpl <em>Organization</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see ESpice.impl.OrganizationImpl
	 * @see ESpice.impl.ESpicePackageImpl#getOrganization()
	 * @generated
	 */
	int ORGANIZATION = 0;

	/**
	 * The feature id for the '<em><b>Widerstand</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ORGANIZATION__WIDERSTAND = 0;

	/**
	 * The feature id for the '<em><b>Stromquelle</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ORGANIZATION__STROMQUELLE = 1;

	/**
	 * The feature id for the '<em><b>Knoten</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ORGANIZATION__KNOTEN = 2;

	/**
	 * The number of structural features of the '<em>Organization</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ORGANIZATION_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link ESpice.impl.BausteinImpl <em>Baustein</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see ESpice.impl.BausteinImpl
	 * @see ESpice.impl.ESpicePackageImpl#getBaustein()
	 * @generated
	 */
	int BAUSTEIN = 4;

	/**
	 * The feature id for the '<em><b>BK</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAUSTEIN__BK = 0;

	/**
	 * The number of structural features of the '<em>Baustein</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAUSTEIN_FEATURE_COUNT = 1;

	/**
	 * The meta object id for the '{@link ESpice.impl.WiderstandImpl <em>Widerstand</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see ESpice.impl.WiderstandImpl
	 * @see ESpice.impl.ESpicePackageImpl#getWiderstand()
	 * @generated
	 */
	int WIDERSTAND = 1;

	/**
	 * The feature id for the '<em><b>BK</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WIDERSTAND__BK = BAUSTEIN__BK;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WIDERSTAND__ID = BAUSTEIN_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Widerstand</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WIDERSTAND_FEATURE_COUNT = BAUSTEIN_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link ESpice.impl.StromquelleImpl <em>Stromquelle</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see ESpice.impl.StromquelleImpl
	 * @see ESpice.impl.ESpicePackageImpl#getStromquelle()
	 * @generated
	 */
	int STROMQUELLE = 2;

	/**
	 * The feature id for the '<em><b>BK</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STROMQUELLE__BK = BAUSTEIN__BK;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STROMQUELLE__ID = BAUSTEIN_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Stromquelle</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STROMQUELLE_FEATURE_COUNT = BAUSTEIN_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link ESpice.impl.KnotenImpl <em>Knoten</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see ESpice.impl.KnotenImpl
	 * @see ESpice.impl.ESpicePackageImpl#getKnoten()
	 * @generated
	 */
	int KNOTEN = 3;

	/**
	 * The feature id for the '<em><b>KK</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KNOTEN__KK = 0;

	/**
	 * The number of structural features of the '<em>Knoten</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KNOTEN_FEATURE_COUNT = 1;


	/**
	 * Returns the meta object for class '{@link ESpice.Organization <em>Organization</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Organization</em>'.
	 * @see ESpice.Organization
	 * @generated
	 */
	EClass getOrganization();

	/**
	 * Returns the meta object for the containment reference list '{@link ESpice.Organization#getWiderstand <em>Widerstand</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Widerstand</em>'.
	 * @see ESpice.Organization#getWiderstand()
	 * @see #getOrganization()
	 * @generated
	 */
	EReference getOrganization_Widerstand();

	/**
	 * Returns the meta object for the containment reference list '{@link ESpice.Organization#getStromquelle <em>Stromquelle</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Stromquelle</em>'.
	 * @see ESpice.Organization#getStromquelle()
	 * @see #getOrganization()
	 * @generated
	 */
	EReference getOrganization_Stromquelle();

	/**
	 * Returns the meta object for the containment reference list '{@link ESpice.Organization#getKnoten <em>Knoten</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Knoten</em>'.
	 * @see ESpice.Organization#getKnoten()
	 * @see #getOrganization()
	 * @generated
	 */
	EReference getOrganization_Knoten();

	/**
	 * Returns the meta object for class '{@link ESpice.Widerstand <em>Widerstand</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Widerstand</em>'.
	 * @see ESpice.Widerstand
	 * @generated
	 */
	EClass getWiderstand();

	/**
	 * Returns the meta object for the attribute '{@link ESpice.Widerstand#getId <em>Id</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Id</em>'.
	 * @see ESpice.Widerstand#getId()
	 * @see #getWiderstand()
	 * @generated
	 */
	EAttribute getWiderstand_Id();

	/**
	 * Returns the meta object for class '{@link ESpice.Stromquelle <em>Stromquelle</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Stromquelle</em>'.
	 * @see ESpice.Stromquelle
	 * @generated
	 */
	EClass getStromquelle();

	/**
	 * Returns the meta object for the attribute '{@link ESpice.Stromquelle#getId <em>Id</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Id</em>'.
	 * @see ESpice.Stromquelle#getId()
	 * @see #getStromquelle()
	 * @generated
	 */
	EAttribute getStromquelle_Id();

	/**
	 * Returns the meta object for class '{@link ESpice.Knoten <em>Knoten</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Knoten</em>'.
	 * @see ESpice.Knoten
	 * @generated
	 */
	EClass getKnoten();

	/**
	 * Returns the meta object for the reference list '{@link ESpice.Knoten#getKK <em>KK</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>KK</em>'.
	 * @see ESpice.Knoten#getKK()
	 * @see #getKnoten()
	 * @generated
	 */
	EReference getKnoten_KK();

	/**
	 * Returns the meta object for class '{@link ESpice.Baustein <em>Baustein</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Baustein</em>'.
	 * @see ESpice.Baustein
	 * @generated
	 */
	EClass getBaustein();

	/**
	 * Returns the meta object for the reference list '{@link ESpice.Baustein#getBK <em>BK</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>BK</em>'.
	 * @see ESpice.Baustein#getBK()
	 * @see #getBaustein()
	 * @generated
	 */
	EReference getBaustein_BK();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	ESpiceFactory getESpiceFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link ESpice.impl.OrganizationImpl <em>Organization</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see ESpice.impl.OrganizationImpl
		 * @see ESpice.impl.ESpicePackageImpl#getOrganization()
		 * @generated
		 */
		EClass ORGANIZATION = eINSTANCE.getOrganization();

		/**
		 * The meta object literal for the '<em><b>Widerstand</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ORGANIZATION__WIDERSTAND = eINSTANCE.getOrganization_Widerstand();

		/**
		 * The meta object literal for the '<em><b>Stromquelle</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ORGANIZATION__STROMQUELLE = eINSTANCE.getOrganization_Stromquelle();

		/**
		 * The meta object literal for the '<em><b>Knoten</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ORGANIZATION__KNOTEN = eINSTANCE.getOrganization_Knoten();

		/**
		 * The meta object literal for the '{@link ESpice.impl.WiderstandImpl <em>Widerstand</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see ESpice.impl.WiderstandImpl
		 * @see ESpice.impl.ESpicePackageImpl#getWiderstand()
		 * @generated
		 */
		EClass WIDERSTAND = eINSTANCE.getWiderstand();

		/**
		 * The meta object literal for the '<em><b>Id</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute WIDERSTAND__ID = eINSTANCE.getWiderstand_Id();

		/**
		 * The meta object literal for the '{@link ESpice.impl.StromquelleImpl <em>Stromquelle</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see ESpice.impl.StromquelleImpl
		 * @see ESpice.impl.ESpicePackageImpl#getStromquelle()
		 * @generated
		 */
		EClass STROMQUELLE = eINSTANCE.getStromquelle();

		/**
		 * The meta object literal for the '<em><b>Id</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute STROMQUELLE__ID = eINSTANCE.getStromquelle_Id();

		/**
		 * The meta object literal for the '{@link ESpice.impl.KnotenImpl <em>Knoten</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see ESpice.impl.KnotenImpl
		 * @see ESpice.impl.ESpicePackageImpl#getKnoten()
		 * @generated
		 */
		EClass KNOTEN = eINSTANCE.getKnoten();

		/**
		 * The meta object literal for the '<em><b>KK</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference KNOTEN__KK = eINSTANCE.getKnoten_KK();

		/**
		 * The meta object literal for the '{@link ESpice.impl.BausteinImpl <em>Baustein</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see ESpice.impl.BausteinImpl
		 * @see ESpice.impl.ESpicePackageImpl#getBaustein()
		 * @generated
		 */
		EClass BAUSTEIN = eINSTANCE.getBaustein();

		/**
		 * The meta object literal for the '<em><b>BK</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference BAUSTEIN__BK = eINSTANCE.getBaustein_BK();

	}

} //ESpicePackage
